## kernel-patch-powerpc-2.6.11 2.6.11-2

=== config/Makefile ===
powerpc default:	powerpc.stub nosmp.stub cpufreq.stub common.stub
	@cat $^
%-smp:	%.stub smp.stub nocpufreq.stub common.stub
	@cat $^
%:	%.stub nosmp.stub nocpufreq.stub common.stub
	@cat $^

=== debian/changelog ===
kernel-patch-powerpc-2.6.11 (2.6.11-2) unstable; urgency=low

  * Built wiht kernel-source 2.6.11-4.
  * Fixed kernel-build/kernel-headers so that kernel-build now include the
    symlinks to all kernel-headers stuff. (Sven Luther)
  * Fixed prep Motorola Powerstack II - Utah irq issues. (Sven Luther)
  * Enabled InfiniBand support, thanks to Troy Benjegerdes for testing and
    providing the config options. (Sven Luther)
  * Add Module.symvers to kernel-build/kernel-headers so out of
    tree modules can detect abi changes, (Simon Horman)
  * Fixed /lib/modules/<version>/source to point to kernel-build stuff if
    installed. (Sven Luther)
  * Disabled the follwoing drivers as they depend on various
    isa_() functions which are not avaibale for powerpc (Simon Horman) :
    - VGA16 Frame Buffer
    - Future Domain PCMCIA SCSI
    - Future Domain SCSI
    - HP 10/100VA PCLAN
    - ARCnet COM90xx (normal)
    - ARCnet COM90xx (RIM-I)

 -- Sven Luther <luther@debian.org>  Fri, 13 May 2005 09:33:54 +0200

kernel-patch-powerpc-2.6.11 (2.6.11-1) unstable; urgency=high

  * New Upstream release.

 -- Sven Luther <luther@debian.org>  Sun,  3 Apr 2005 23:57:42 +0200

kernel-patch-powerpc-2.6.10 (2.6.10-3) unstable; urgency=high

  * Removed again the bootloader postinst boot magic, as it caused bad
    interaction between make-kpkg and debconf. (Sven Luther)
  * Now copy kernel-source's changelog fil in the kernel-image.
  * Rebuilt against kernel-source 2.6.10-5.

 -- Sven Luther <luther@debian.org>  Wed, 23 Feb 2005 14:30:04 +0100

kernel-patch-powerpc-2.6.10 (2.6.10-2) unstable; urgency=high

  * Added kernel postinst magic to be sure we do the right thing in the
    mkvmlinuz case. (Sven Luther)

 -- Sven Luther <luther@debian.org>  Tue,  8 Feb 2005 21:05:01 +0100

kernel-patch-powerpc-2.6.10 (2.6.10-1) unstable; urgency=high

  * New upstream release. (Sven Luther)
  * Disable CONFIG_BLK_DEV_UB. (See: #284952, #283852) (Simon Horman)

 -- Sven Luther <luther@debian.org>  Sun,  6 Feb 2005 18:47:28 +0100

kernel-patch-powerpc-2.6.9 (2.6.9-4) unstable; urgency=high

  * Rebuilt against kernel-source-2.6.9-5 (Sven Luther) :
    - [powerpc] Added a couple of powermac patches from Benjamin Herrenschmidt :
      - 970FX cpu support
      - G5 thermal management update
      - Misc powermac fixes backports
      (Bug #287030) (Sven Luther)
    - [powerpc] Moved from powerpc kernel-patch package :
      - powermac legacy serial fix.
      - pegasos via-ide dual interrupt fix.
      (Sven Luther)
    - [powerpc] Added _chrp_type support though pegasos patch (Sven Luther)
    - [powerpc - prep] Fix bad irq assignement for pci devices on motorola
      powerstack boxes. (Sven Luther)
    - add dh_fixperms to the build targets to kernel-patch-debian-2.6.9
      to ensure that the permissions of the files in this package are
      sensible. (See: Bug#288279) (Simon Horman)
    - [SECURITY] Fix vulnerability in the ELF loader code allowing
      local attacker to execute code as root; CAN-2004-1235. 
      (Maximilian Attems)
    - [SECURITY] 028-do_brk_security_fixes.dpatch
      Drop Marcelo's fix, use Linus' instead.
      Fix local root vulnerability for various do_brk() calls;
      ensure an exclusive lock on memory while modifying it; CAN-2004-1235
      (Andres Salomon) (closes: #289155).
    - [SECURITY] 029-random_poolsize_overflow.dpatch
      drivers/char/random allows you to set the poolsize; its sanity checking
      on that input isn's very good.  We fix that here.
      See http://seclists.org/lists/fulldisclosure/2005/Jan/0270.html for
      more details.  This fixes #3 on that list (Andres Salomon).
    - [SECURITY] 030-moxa_user_copy_checking.dpatch
      The moxa driver does some ugly things w/ signed integers.  This fixes
      #4 on Brad Spengler's advisory (Andres Salomon).
    - [SECURITY] 031-sg_scsi_ioctl_int_overflows.dpatch
      SG ioctl stuff doesn't actually check whether the scsi command length
      is positive.  #5 on the above advisory (Andres Salomon).

  * Removed kernel-patch-powerpc package, since all the powerpc patches are
    now part of kernel-source. Next version of kernel-source-2.6.9 should
    have a conflict/replace/provides, but for now please remove it by hand.
    (Sven Luther)

 -- Sven Luther <luther@debian.org>  Sun,  9 Jan 2005 15:31:57 +0100

kernel-patch-powerpc-2.6.9 (2.6.9-3) unstable; urgency=low

  * Sven Luther :
    Rebuilt since i forgot to remove completely the metapackages from the
    changes file, and as a result -2 is in some kind of incoming/UNACCEPT
    no-man's land. Since built time is >9 hours, let's not take chance and
    upload -3 :/

 -- Sven Luther <luther@debian.org>  Fri, 10 Dec 2004 18:44:34 +0100

kernel-patch-powerpc-2.6.9 (2.6.9-2) unstable; urgency=low

  * Compiled SELinux support into the kernel, but left it disabled by
    default at boot time.  Thanks to Manoj Srivastava for investigating
    the issue and suggesting the necessary .config changes.

  * Rebuilt against kernel-source 2.6.9-3 (Sven Luther) :
    - Include dm_io-ENOMEM-goof patch that was included in final 2.6.8-8
      (Andres Salomon).
    - [SECURITY] Further binfmt_elf fixes, and binfmt_aout fixes as well
      (Andres Salomon).
    - [SECURITY] Further smbfs overflow fixes, stolen from -ac tree
      (Andres Salomon).
    - Add missing check for tty == NULL in uart_tasklet_action to fix an init
      oops on serial console. (Joshua Kwan)
    - Adding drivers-serial-8250-ioremap-fix.dpatch: a patch from Alex
      Williamson that prevents setserial from crashing the kernel. See:
      http://marc.theaimsgroup.com/?l=linux-kernel&m=109913237604338&w=2
      (Dann Frazier)
    - VLAN updates (Potential fix for: Bug#280743) (Simon Horman)
    - Remove bogus DMA blacklist for RICOH CD-R/RW MP7083A (Maximilian Attems)
    - tmpfs inode accounting leak fix (Maximilian Attems)
    - [SECURITY] Fix problems in binfmt_elf loader; see


=== debian/control ===
Source: kernel-patch-powerpc-2.6.11
Section: devel
Priority: optional
Build-Depends: debhelper (>=4 ), bzip2, kernel-package (>> 8.119), kernel-tree-2.6.11, m4
Maintainer: Debian Kernel Team <debian-kernel@lists.debian.org>
Uploaders: Sven Luther <luther@debian.org>
Standards-Version: 3.6.1

Package: kernel-headers-2.6.11-powerpc
Architecture: powerpc
Description: header files for the Linux kernel version 2.6.11
 .
 This package provides kernel headers files for 2.6.11.

Package: kernel-build-2.6.11-power3
Architecture: powerpc
Depends: kernel-headers-2.6.11-powerpc
Description: build infrastructure for kernel version 2.6.11-power3
 .
 Together with kernel-headers-2.6.11-powerpc, this package provides the
 infrastructure for building additional modules for 2.6.11-power3.

Package: kernel-image-2.6.11-power3
Section: base
Architecture: powerpc
Depends: initrd-tools (>= 0.1.65), module-init-tools, mkvmlinuz
Recommends: hotplug
Provides: kernel-image, kernel-image-2.6
Description: Linux kernel image for 2.6.11-power3
 .
 This package contains the Linux kernel for version 2.6.11-power3.
 It is intended to be run on PowerPC machines with a single Power3
 processor.

Package: kernel-build-2.6.11-power3-smp
Architecture: powerpc
Depends: kernel-headers-2.6.11-powerpc
Description: build infrastructure for kernel version 2.6.11-power3-smp
 .
 Together with kernel-headers-2.6.11-powerpc, this package provides the
 infrastructure for building additional modules for 2.6.11-power3-smp.

Package: kernel-image-2.6.11-power3-smp
Section: base
Architecture: powerpc
Depends: initrd-tools (>= 0.1.65), module-init-tools, mkvmlinuz
Recommends: hotplug
Provides: kernel-image, kernel-image-2.6
Description: Linux kernel image for 2.6.11-power3-smp
 .
 This package contains the Linux kernel for version 2.6.11-power3-smp.
 It is intended to be run on PowerPC machines with two or more
 Power3 processors, like some IBM RS/6000 boxen.

Package: kernel-build-2.6.11-power4
Architecture: powerpc
Depends: kernel-headers-2.6.11-powerpc
Description: build infrastructure for kernel version 2.6.11-power4
 .
 Together with kernel-headers-2.6.11-powerpc, this package provides the
 infrastructure for building additional modules for 2.6.11-power4.

Package: kernel-image-2.6.11-power4
Section: base
Architecture: powerpc
Depends: initrd-tools (>= 0.1.65), module-init-tools, mkvmlinuz
Recommends: hotplug
Provides: kernel-image, kernel-image-2.6
Description: Linux kernel image for 2.6.11-power4
 .
 This package contains the Linux kernel for version 2.6.11-power4.
 It is intended to be run on PowerPC machines with a single Power4
 processor, the most prominent example being the G5 PowerMac by Apple.

Package: kernel-build-2.6.11-power4-smp
Architecture: powerpc
Depends: kernel-headers-2.6.11-powerpc
Description: build infrastructure for kernel version 2.6.11-power4-smp
 .
 Together with kernel-headers-2.6.11-powerpc, this package provides the
 infrastructure for building additional modules for 2.6.11-power4-smp.

Package: kernel-image-2.6.11-power4-smp
Section: base
Architecture: powerpc
Depends: initrd-tools (>= 0.1.65), module-init-tools, mkvmlinuz
Recommends: hotplug
Provides: kernel-image, kernel-image-2.6
Description: Linux kernel image for 2.6.11-power4-smp
 .
 This package contains the Linux kernel for version 2.6.11-power4-smp.
 It is intended to be run on PowerPC machines with two or more Power4
 processors.  This setup can be found in Apple's dual G5 PowerMacs, as
 well as in a number of IBM RS/6000 boxen, such as the iSeries and
 pSeries machines.

Package: kernel-build-2.6.11-powerpc
Architecture: powerpc
Depends: kernel-headers-2.6.11-powerpc
Description: build infrastructure for kernel version 2.6.11-powerpc
 .
 Together with kernel-headers-2.6.11-powerpc, this package provides the
 infrastructure for building additional modules for 2.6.11-powerpc.

Package: kernel-image-2.6.11-powerpc
Section: base
Architecture: powerpc
Depends: initrd-tools (>= 0.1.65), module-init-tools, mkvmlinuz
Recommends: hotplug
Provides: kernel-image, kernel-image-2.6
Description: Linux kernel image for 2.6.11-powerpc
 .
 This package contains the Linux kernel for version 2.6.11-powerpc.
 It is intended to be run on single-processor PowerPC machines,
 including all G3 and G4 models by Apple, as well as older PowerMacs.

Package: kernel-build-2.6.11-powerpc-smp
Architecture: powerpc
Depends: kernel-headers-2.6.11-powerpc
Description: build infrastructure for kernel version 2.6.11-powerpc-smp
 .
 Together with kernel-headers-2.6.11-powerpc, this package provides the
 infrastructure for building additional modules for 2.6.11-powerpc-smp.

Package: kernel-image-2.6.11-powerpc-smp
Section: base
Architecture: powerpc
Depends: initrd-tools (>= 0.1.65), module-init-tools, mkvmlinuz
Recommends: hotplug
Provides: kernel-image, kernel-image-2.6
Description: Linux kernel image for 2.6.11-powerpc-smp
 .
 This package contains the Linux kernel for version 2.6.11-powerpc-smp.
 It is intended to be run on most dual-processor PowerPC machines,
 most notably the Dual G4 PowerMacs by Apple.

=== debian/rules ===
#!/usr/bin/make -f

# debian/rules for kernel-patch-powerpc

# written by Jens Schmalzing <jensen@debian.org>

# debhelper compatibility version
export DH_COMPAT=4

# Set to Yes if we are going to generate the metapackages.
OFFICIAL_VERSION = No

# set the build architecture if necessary
DEB_HOST_ARCH ?= $(shell dpkg --print-architecture)

# the flavours we're building for
flavours := $(shell grep -v ^\# debian/flavours)

# cut the upstream version and the Debian revision from the changelog
kernel	:= $(shell head -1 debian/changelog | sed 's/^.*(\(.*\)-.*).*$$/\1/')
debian	:= $(shell head -1 debian/changelog | sed 's/^.*(.*-\(.*\)).*$$/\1/')
version	:= $(shell head -1 debian/changelog | sed 's/^.*(\(.*\)).*$$/\1/')

#some files in debian/ get version numbers and stuff updated on the fly
M4 = m4 -DM4VERSION="$(version)" -DM4KERNEL="$(kernel)" -DM4FLAVOUR="$(flavour)"
debian/%: debian/%.m4
	$(M4) $< > $@

# installation of files and programs
INSTALL_DATA	= install -m 644 -o root -g root
INSTALL_EXEC	= install -m 755 -o root -g root

# build locations - point TMP to a tmpfs for best performance
TMP ?= $(CURDIR)/tmp
KSOURCE	 = $(TMP)/kernel-source-$(kernel)
KFLAVOUR = $(TMP)/kernel-source-$(kernel)-$(flavour)
KDUMMY   = $(TMP)/kernel-image-$(kernel)-$(flavour)_$(version)_powerpc.deb
KHEADERS = $(TMP)/kernel-headers-$(kernel)-powerpc_$(version)_powerpc.deb

# install locations
KBUILD    = $(CURDIR)/debian/kernel-build-$(kernel)-$(flavour)
KBUILDDOC = $(KBUILD)/usr/share/doc/kernel-build-$(kernel)-$(flavour)
KSRC      = $(KBUILD)/usr/src/kernel-build-$(kernel)-$(flavour)
KIMAGE    = $(CURDIR)/debian/kernel-image-$(kernel)-$(flavour)
KIMAGEDOC = $(KIMAGE)/usr/share/doc/kernel-image-$(kernel)-$(flavour)
KLIB      = $(KIMAGE)/usr/lib/kernel-image-$(kernel)-$(flavour)

# environment for make-kpkg
export APPEND_TO_VERSION=-$(flavour)
#export PARALLEL_BUILD=-j2
export CONCURRENCY_LEVEL=8
export INITRD=Yes
export INITRD_OK=WeKnowWhatWeAreDoing
export KPKG_SUBARCH=pmac

# the configure target is responsible for setting up the build arena,
# i.e. unpacking the Debian kernel source and preparing a separate
# build tree for each flavour.

configure: stamp-configure

# the following is the first of a number of loop implementations using
# recursive make.  This provides much easier access to the loop
# variable than extracting it from the target.  In order to safeguard
# against infinite loops, the recursion level is checked for the
# critical targets.  This particular example calls a common target,
# then runs the loop, and also includes some common commands to
# process after the loop.

stamp-configure: \
stamp-configure-prepare \
$(foreach flavour,$(flavours),stamp-configure-flavour-$(flavour))

	cd $(KSOURCE); APPEND_TO_VERSION='' make-kpkg configure

	touch $@

# unpack the Debian kernel source, add a default .config file and the
# necessary Debian files (changelog, control, copyright, post-install,
# and official)
stamp-configure-prepare:

	test -d $(dir $(KSOURCE)) || mkdir -p $(dir $(KSOURCE))
	tar jxCf $(dir $(KSOURCE)) /usr/src/kernel-source-$(kernel).tar.bz2
	#cd $(KSOURCE); /usr/src/kernel-patches/all/$(kernel)/apply/debian
	#for file in $(shell debian/list patches); do patch -d $(KSOURCE) -p1 < patches/$$file; done

	-$(MAKE) -s -C config default > $(KSOURCE)/.config

	test -d $(KSOURCE)/debian || mkdir $(KSOURCE)/debian
	cd debian; cp -p changelog control copyright post-install $(KSOURCE)/debian
	> $(KSOURCE)/debian/official

	touch $@

ifeq (0,$(MAKELEVEL))

stamp-configure-flavour-%:
	$(MAKE) -f debian/rules stamp-configure-flavour-$* flavour=$*

else
ifeq (1,$(MAKELEVEL))

# create a separate build tree for a given flavour, add the flavour's
# .config and control files
stamp-configure-flavour-$(flavour): \
stamp-configure-prepare

	test -d $(dir $(KFLAVOUR)) || mkdir -p $(dir $(KFLAVOUR))

	cp -al $(KSOURCE) $(KFLAVOUR)

	rm -f $(KFLAVOUR)/.config $(KFLAVOUR)/debian/control
	-$(MAKE) -s -C config $(flavour) > $(KFLAVOUR)/.config
	$(M4) debian/control-dummy.m4 > $(KFLAVOUR)/debian/control
	$(M4) debian/dirs-image.m4 >> debian/kernel-image-$(kernel)-$(flavour).dirs

	touch $@

endif
endif

# the build target is responsible for, well, building the kernels and
# modules for each flavour.  To that end, it uses the build target of
# make-kpkg.

ifeq ($(DEB_HOST_ARCH),powerpc)
build: stamp-build
else
build:
endif

stamp-build: \
stamp-configure stamp-build-prepare
	$(MAKE) -f debian/rules $(PARALLEL_BUILD) $(foreach flavour,$(flavours),stamp-build-flavour-$(flavour))
	touch $@

stamp-build-prepare:
	dh_testdir
	touch $@

ifeq (0,$(MAKELEVEL))

stamp-build-flavour-%:
	$(MAKE) -f debian/rules $@

else
ifeq (1,$(MAKELEVEL))

stamp-build-flavour-%:
	$(MAKE) -f debian/rules stamp-build-flavour-$* flavour=$*

else
ifeq (2,$(MAKELEVEL))

# build the pmac kernel and the modules for a given flavour
stamp-build-flavour-$(flavour): \
stamp-configure-flavour-$(flavour) stamp-build-prepare
	cd $(KFLAVOUR); \
	MFLAGS="$(filter-out -j --j%,$(MFLAGS))" \
	MAKEFLAGS="$(filter-out -j --j%,$(MAKEFLAGS))" make-kpkg build
	touch $@

endif
endif
endif

# the install target is responsible for assigning the built kernels
# and modules to the right kernel-image and kernel-modules packages.
# The main work is done through the kernel-image target of make-kpkg.
# The resulting intermediate package is immediately unpacked again and
# its contents re-arranged slightly. The whole process results in one
# kernel-image directory per flavour. Also, the install target puts
# together the build infrastructure for modules.

install: stamp-install

stamp-install: \
stamp-build
	$(MAKE) -f debian/rules $(PARALLEL_BUILD) $(foreach flavour,$(flavours),stamp-install-flavour-$(flavour))
	touch $@

# do the usual checks
stamp-install-prepare:
	dh_testdir
	dh_testroot
	dh_clean

	touch $@

ifeq (0,$(MAKELEVEL))

stamp-install-flavour-%:
	$(MAKE) -f debian/rules $@

else
ifeq (1,$(MAKELEVEL))

stamp-install-flavour-%:
	$(MAKE) -f debian/rules stamp-install-flavour-$* flavour=$*

else
ifeq (2,$(MAKELEVEL))

# create an intermediate kernel-image package from the build tree,
# immediately unpack it into the install directory, and re-arrange a
# few things.  Also, install the build infrastructure for modules from
# the kernel source.

stamp-install-flavour-$(flavour): \
stamp-build-flavour-$(flavour) stamp-install-prepare

# create and unpack the intermediate kernel image package
	cd $(KFLAVOUR); \
	MFLAGS="$(filter-out -j --j%,$(MFLAGS))" \
	MAKEFLAGS="$(filter-out -j --j%,$(MAKEFLAGS))" make-kpkg kernel-image
	dpkg -x $(KDUMMY) $(KIMAGE)

# remove the coff image
	rm -f $(KIMAGE)/boot/vmlinux.coff-$(kernel)-$(flavour)

# copy build infrastructure for kernel modules
	cd $(KFLAVOUR); find scripts -type f ! -name '*.o' | cpio -pd $(KSRC)
	cat debian/build-files | ( cd $(KFLAVOUR); cpio -pd $(KSRC) )
	for file in `cat debian/build-links`; do \
		tmp=$$file; \
		link=".." ; \
		while [ `dirname $$tmp` != "." ]; do \
			link="$$link/.."; \
			tmp=`dirname $$tmp`; \
		done; \
		ln -sf $$link/kernel-headers-$(kernel)-$(flavour)/$$file $(KSRC)/$$file; \
	done
	ln -sf asm-ppc $(KSRC)/include/asm
	mkdir -p $(KBUILD)/lib/modules/$(kernel)-$(flavour)
	ln -sf ../../../usr/src/kernel-build-$(kernel)-$(flavour) \
		$(KBUILD)/lib/modules/$(kernel)-$(flavour)/build
	ln -sf ../../../usr/src/kernel-build-$(kernel)-$(flavour) \
		$(KBUILD)/lib/modules/$(kernel)-$(flavour)/source

# add some README files and the kernel-source changelog
	$(INSTALL_DATA) debian/README.kernel-image $(KIMAGEDOC)/NEWS.Debian
	$(INSTALL_DATA) /usr/share/doc/kernel-source-$(kernel)/changelog.Debian.gz \
		$(KIMAGEDOC)/changelog-kernel-source.Debian.gz
	mkdir -p $(KBUILDDOC)
	$(INSTALL_DATA) debian/README.kernel-build $(KBUILDDOC)/README.Debian

	touch $@

endif
endif
endif

# the binary target is responsible for creating Debian packages from
# the various package directories created by the install target.
